#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <sys/un.h>
#include <netinet/in.h>

#include "message.h"

int    unix_socket_fd;
fd_set select_fd_set;

struct timeval timeout;

struct sockaddr_un localaddr;
struct sockaddr_un remoteaddr;
socklen_t remoteaddr_len;

struct licks_message message;

char *ikd_path="/tmp/ikd"; // might move to a header

int
main(int argc, char **argv) {
   int l,i,quit;
   unix_socket_fd=socket(PF_LOCAL,SOCK_DGRAM,0);
   if(unix_socket_fd==-1) {
      perror("socket");
      exit(0);
   }
   printf("socket %d\n",unix_socket_fd);
//   localaddr.sun_len=strlen(ikd_path);
   localaddr.sun_family=AF_LOCAL;
   strcpy(localaddr.sun_path,ikd_path);

   unlink(ikd_path);   
   if(bind(unix_socket_fd,(struct sockaddr *)&localaddr,sizeof(struct sockaddr_un))) {
      perror("bind");
      exit(0);
   }
   printf("bound\n");
   quit=0;
   while(!quit) {
      FD_ZERO(&select_fd_set);
      FD_SET(unix_socket_fd,&select_fd_set);
      timeout.tv_sec=1;
      timeout.tv_usec=0;
      if(!select(unix_socket_fd+1,&select_fd_set,NULL,NULL,&timeout)) {
         printf("timeout\n");
      } else {
         remoteaddr_len=sizeof(struct sockaddr_un);
         l=recvfrom(unix_socket_fd,&message,sizeof(struct licks_message),0,(struct sockaddr *)&remoteaddr,&remoteaddr_len);
         printf("recvfrom: %d\n",l);
//         printf("sun_len: %d\n",remoteaddr.sun_len);
         printf("sun_addr: %s\n",remoteaddr.sun_path);
         printf("message type: %d\n",message.type);
         for(i=0;i<32;i++) {
            if(!(i%8)) { printf("\n"); }
            printf("%02x ",message.char_array[i]);
         }
         printf("\n\nsending reply\n\n");
         message.type=MSG_REPLY;
         l=sendto(unix_socket_fd,&message,sizeof(struct licks_message),0,(struct sockaddr *)&remoteaddr,sizeof(struct sockaddr_un));
      }

   }

   close(unix_socket_fd);
   unlink(ikd_path);   
   return 0;
}