import sys
import time
import board
import busio
import json

from adafruit_motor import servo
from adafruit_pca9685 import PCA9685

filename = sys.argv[1]
with open(filename, "r") as f:
    calibration = json.load(f)
    
print(calibration)

i2c = busio.I2C(board.SCL, board.SDA)
pca = PCA9685(i2c)

pca.frequency = 50
servo = servo.Servo(pca.channels[15], actuation_range = 180, min_pulse=round(calibration['intercept']), max_pulse=round(calibration['intercept'] + 180 * calibration['slope']))

for i in range(0, 3):
    servo.angle = 90
    time.sleep(0.2)
    servo.angle = 70
    time.sleep(0.2)

servo.angle = 90

pca.channels[15].duty_cycle=0
